--- spice-gtk/src/spice-channel.c.orig	2018-02-23 16:53:45.492135607 +1100
+++ spice-gtk/src/spice-channel.c	2018-02-23 13:14:52.744060495 +1100
@@ -49,6 +49,10 @@
 
 #include "gio-coroutine.h"
 
+#ifndef G_IO_ERROR_NOT_CONNECTED
+# define G_IO_ERROR_NOT_CONNECTED	(G_IO_ERROR_BROKEN_PIPE+1)
+#endif
+
 static void spice_channel_handle_msg(SpiceChannel *channel, SpiceMsgIn *msg);
 static void spice_channel_write_msg(SpiceChannel *channel, SpiceMsgOut *out);
 static void spice_channel_send_link(SpiceChannel *channel);
--- spice-gtk/src/spicy.c.orig	2018-02-23 16:39:02.676101271 +1100
+++ spice-gtk/src/spicy.c	2018-02-23 16:49:27.721105546 +1100
@@ -243,8 +243,7 @@ static void update_edit_menu_window(Spic
     GtkAction *toggle;
     gboolean disabled_entries[G_N_ELEMENTS(spice_edit_properties)] = {
         disable_copy_to_guest,
-        disable_paste_from_guest,
-        false };
+        disable_paste_from_guest };
 
     if (win == NULL) {
         return;
@@ -1274,8 +1273,10 @@ static void share_current_printers(gpoin
 void realize_window(GtkWidget * toplevel, gpointer data)
 {
     if (fullscreen_on_all_monitors) {
-        gdk_window_set_fullscreen_mode(gtk_widget_get_window(toplevel),
-                                       GDK_FULLSCREEN_ON_ALL_MONITORS);
+        /* GTK3-specific, so fullscreen_on_all_monitors under GTK2 just means
+         * the same as fullscreen */
+        /* gdk_window_set_fullscreen_mode(gtk_widget_get_window(toplevel),
+                                       GDK_FULLSCREEN_ON_ALL_MONITORS); */
         fullscreen = TRUE;
     }
     if (fullscreen || kiosk_mode)
